/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

public class DimensionExpression extends PreviousExpression
{
  public static final int AUTO=0;

  boolean auto=false;

  public DimensionExpression()
  {
	}

	public DimensionExpression(DimensionExpression exp)
	{
		super(exp);
	}

  public boolean isAuto()
  {
		return auto;
	}

  public void setAuto()
  {
    auto=true;
    super.setExpression(null);
  }

  public boolean isAbsolute()
  {
		if (auto)
		  return false;
		return super.isAbsolute();
	}

  public String getExpression()
  {
		if (auto)
		  return Keywords.get(this,AUTO);
		return super.getExpression();
	}

  public void setExpression(String s)
  {
		auto=Keywords.get(this,s)==AUTO;
		if (auto)
		  s=null;
		super.setExpression(s);
	}

	public void setValue(int i)
	{
		auto=false;
		super.setValue(i);
	}
}
