/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

import java.awt.*;
import java.awt.event.*;

public class TextEditor extends Frame implements TextListener
{
	TextField edit;
	TextArea area;
	String editText;
	String areaText;
	boolean listMode=false;

	public TextEditor()
	{
		if (!Preferences.registerFrame("TextEditor",this))
		  setSize(200,200);
		//add("North",edit=new TextField());
		//edit.addTextListener(this);
		add(area=new TextArea(null,0,0,TextArea.SCROLLBARS_VERTICAL_ONLY));
		area.addTextListener(this);
  }

  public void setListMode(boolean b)
  {
		listMode=b;
	}

  public void setTextField(String title,TextField field)
  {
		setTitle(title);
		if (edit!=null)
		  edit.removeTextListener(this);
		edit=field;
		edit.addTextListener(this);
		edit.setText(edit.getText());
		//System.out.println(s);
		//edit.setText(s);
	}

	public String getText(String s)
	{
		return edit.getText();
	}

	public void textValueChanged(TextEvent e)
	{
    if (e.getSource()==edit)
    {
			String s=edit.getText();
			if (!s.equals(editText))
			{
				editText=s;
				if (listMode)
  				areaText=TextTools.unescape(TextTools.join(TextTools.split(editText,','),'\n'));
  		  else
  		    areaText=TextTools.unescape(editText);
				area.setText(areaText);
			}
		}
		else
		if (e.getSource()==area)
		{
			String s=area.getText();
			{
				if (!s.equals(areaText))
				{
					areaText=s;
					if (edit!=null)
					{
						if (listMode)
						  editText=TextTools.join(TextTools.split(TextTools.escape(areaText,"\t\\",false),'\n'),',');
						else
						  editText=TextTools.escape(areaText);
						edit.setText(editText);
					}
				}
			}
		}
	}

  public static void main(String[] args)
  {
		(new TextEditor()).setVisible(true);
	}
}

